functor
import
   Tk
%   System
   Browser
export
   GraphicClass
   StringNode
   SendNode
   ReceiveNode
   Line
define
   BrO = {New Browser.'class' init}
   {BrO option(representation virtualStrings:true)}
   proc{Browse X} {BrO browse(X)} end

   %% Fontsize
   BoxFont={New Tk.font tkInit(size:8 family:helvetica)}

   %% Max string length (string node)
   MaxStringLength=12

   YDistance = 30
   Width     = 20
   Height    = 10
   Pin       = 10
   class GraphNode
      prop locking 
      feat x canvas tag string color type
      attr y 
      meth init(x:X canvas:C y:Y msg:Msg color:Col short:T <= Msg)
	 self.x = X 
	 self.canvas = C
	 self.color=Col
	 self.tag = {New Tk.canvasTag tkInit(parent:C)}
	 y  <-   Y
	 self.type =
	 {fun{$  T}
	     if {Length T} > MaxStringLength then
		{List.take T MaxStringLength-3}#"..."
	     else
		T
	     end
	 end
	  if {String.is T} then T
	  else {Value.toVirtualString T 10 10} end}
	 

	 self.string =  if {String.is Msg} then Msg
			else {Value.toVirtualString Msg 10 10} end
	 {self.tag tkBind(action:proc{$} {Browse self.string} end event:'<1>')}
	 %{self.tag tkBind(event:'<Enter>' action:self#msgPrint)}
	 %{self.tag tkBind(event:'<Leave>' action:self#msgRemove)}
      end
      meth getY($) @y     end
      meth getX($) self.x end
      meth setY(Y)
	 if @y \= Y then
	    y <- Y
	    {self.tag tk(delete)}
	    {self display}
	 end
      end
      meth msgPrint
	 X0 X1 Y0 Y1 in
	 {self msgRemove}
	 {self.canvas tk(crea text {self getX($)}+10 {self getY($)}*YDistance-10
			 o(text:self.string tags:q(msgPrint tmpTag)))}
	 [X0 Y0 X1 Y1]={self.canvas tkReturnListInt(bbox tmpTag $)}
	 {self.canvas tk(crea rectangle
		X0-4 Y0 X1+4 Y1
		fill:yellow tags:msgPrint)}
	 {self.canvas tk('raise' tmpTag)}
      end

      meth msgRemove
	 {self.canvas tk(delete msgPrint)}
      end
   end

   class StringNode from GraphNode
      feat string
		       
      meth display
	 Y = @y * YDistance 
	 H = Height
	 W = Width
      in
	 {self.canvas tk(crea oval
			 self.x - W   Y - H
			 self.x + W   Y + H
			 fill:white
			 outline:self.color
			 width:2
			 tags: q(alltag self.tag))}
	 {self.canvas tk(crea text self.x Y font:BoxFont
			 text: self.type
			 tags:q(self.tag texttag))}
      end
   end
   	       
   class ReceiveNode from GraphNode
      attr line:true
      meth setLine($) L = @line in line <- false  L end
      meth display
	 Y = @y * YDistance
	 X = self.x
	 H = Height
	 W = Width
	 P = Pin
      in
	 {self.canvas tk(crea poly
			  {self.op1 X  W}   Y -H
			 {self.op2 X   (W+ P)} Y -H
			 {self.op2 X W}  Y
			 {self.op2 X   (W+ P)} Y +H
			 {self.op1 X  W}   Y +H
			 fill:white
			 outline:self.color
			 width:2
			 tags: q(alltag self.tag))}
	 {self.canvas tk(crea text self.x Y font:BoxFont
			 text:self.type
			 tags:q(self.tag texttag))}
      end
   end

   class ReceiveLeft from ReceiveNode
      feat op1:Number.'+'
	 op2:Number.'-'
			
   end

   class ReceiveRight from ReceiveNode
      feat op1:Number.'-'
	 op2:Number.'+'
   end
   
   
   class SendNode from GraphNode
      feat op1:Number.'+'
	 op2:Number.'-'
      meth display
	 Y = @y * YDistance
	 X = self.x
	 H = Height
	 W = Width
	 P = Pin
	 
      in
	 {self.canvas tk(crea poly
			 {self.op1 X  W}   Y -H
			 {self.op2 X  W}   Y -H
			 {self.op2 X   (W+ P)} Y 
			 {self.op2 X  W}   Y + H
			 {self.op1 X  W}   Y + H
			 fill:white
			 outline:self.color
			 width:2
			 tags: q(alltag self.tag))}
	 {self.canvas tk(crea text self.x Y font:BoxFont
			 text:self.type
			 tags:q(self.tag texttag))}
      end
   end
   
   class SendLeft from SendNode
      feat op1:Number.'+'
	 op2:Number.'-'
			
   end

   class SendRight from SendNode
      feat op1:Number.'-'
	 op2:Number.'+'
   end
   class Line
      meth display(X0A Y Rec Can)
	 X1A={Rec getX($)}
	 Y0=Y*YDistance  Y1={Rec getY($)} * YDistance
	 [X0 X1]=if X0A<X1A then [X0A+Width+Pin X1A-Width-1] else [X0A-Width-Pin X1A+Width] end
      in
	 
	 {Can tk(crea line
		 X0 Y0 X1 Y1
		 fill:black
		 width:1
		 arrow:last
		 tags:Rec.tag
		 capstyle:round)}
      end
   end
   

   %% Default color mapping (guaranteed to have no match in the colormapping)...
   NoColorMapping={NewName}
   
   class GraphicClass
      feat db x canvas cm
      attr y:0 

      meth init(canvas:C x:X colorMapping:CM<=unit)
	 self.db = {NewDictionary}
	 self.canvas = C
	 self.x = X
	 self.cm=CM
      end

      meth string(id:Id msg:S type:T<=NoColorMapping short:Short<=S)
	 y <- @y + 1
	 N = {New StringNode init(canvas:self.canvas
				  x:self.x y:@y
				  color:{CondSelect self.cm T black}
				  msg:S short:Short)}
      in
	 {N display}
	 {Dictionary.put self.db Id N}
      end
      meth send(id:Id msg:Msg type:T<=NoColorMapping short:Short<=Msg dir:Dir <= right)
	 y <- @y + 1
	 N = {New r(right:SendRight left:SendLeft).Dir  init(canvas:self.canvas
							     x:self.x y:@y
							     color:{CondSelect self.cm T black}
							     msg:Msg
							     short:Short)}
      in
	 {N display}
	 {Dictionary.put self.db Id N}
      end
      meth receive(id:Id msg:Msg type:T<=NoColorMapping short:Short<=Msg  dir:Dir <= right)
	 y <- @y + 1
	 N = {New  r(right:ReceiveRight left:ReceiveLeft).Dir init(canvas:self.canvas
				   x:self.x y:@y
				   color:{CondSelect self.cm T black}
				   msg:Msg
				   short:Short)}
      in
	 {N display}
	 {Dictionary.put self.db Id N}
      end
      meth solve(id:Id y:Y)
	 N = {Dictionary.get self.db Id}
      in
	 {N setY(Y)}
	 y <- {Max Y @y}
      end

      meth getXY(Id $) self.x#{self.db.Id getY($)} end
      meth createLine(XY Id)
	 if {self.db.Id setLine($)} then
	    _ = {New Line display(XY.1 XY.2 self.db.Id self.canvas)}
	 end
      end
   end
end
