functor
export
   NodeLinkFrame
   GNode
   GLink
import
   Tk
   TkUtils(addScrollbars:AddScrollbars) at '../TkUtils.ozf'
   Utils(convert:Convert) at '../Utils.ozf'
   Browser
define
   % Settings - move to some better place
   MsgRadius=4
   TextOffset=10
   
   class NodeLinkFrame from Tk.frame
      feat
	 canvas
	 
      meth tkInit(parent:Parent width:W height:H)
	 SX SY
      in
	 Tk.frame, tkInit(parent:Parent)
	 self.canvas={New NodeLinkCanvas
		      tkInit(parent:self width:W height:H)}
	 SX#SY={AddScrollbars self self.canvas}
	 {Tk.batch [grid(self.canvas row:0 column:0 sticky:news)
		    grid(SY row:0 column:1 sticky:news)
		    grid(SX row:1 column:0 columnspan:1 sticky:news)
		    grid(columnconfigure self 0 weight:1)
		    grid(rowconfigure self 0 weight:1)]}
      end
   end
   
   class NodeLinkCanvas from Tk.canvas
      feat
	 tag
	 width
	 height
	
      meth tkInit(parent:Parent width:W height:H)
	 Tk.canvas, tkInit(parent:Parent bg:white width:W height:H)
	 self.tag={New Tk.canvasTag tkInit(parent:self)}
	 self.width=W
	 self.height=H
      end

      meth setScrollRegion
	 B = 10 
	 [X0 Y0 X1 Y1]={self tkReturnListInt(bbox self.tag $)}      
      in
	 {self tk(configure scrollregion:q(X0-B Y0-B X1+B Y1+B))}
      end
   end

   class GNode
      prop locking
      attr coords color text
      feat
	 tag canvas textTag
	 width
      meth init(id:ID coords:XY color:C parent:Canvas width:W popup:Popup)
	 X#Y=XY
	 Tag={New Tk.canvasTag tkInit(parent:Canvas)}
      in
	 self.tag=Tag
	 self.canvas = Canvas
	 self.width=W
	 coords<-XY
	 color<-C
	 text<-none
	 {Canvas tk(crea rectangle
		    X-(W div 2) Y-(W div 2) X+(W div 2) Y+(W div 2)
		    width:1
		    fill:@color
		    outline:black
		    tags:q(self.canvas.tag Tag))}
	 {Canvas tk(crea text X Y-20 o(text:ID) tag:self.tag)}
	 self.textTag={New Tk.canvasTag tkInit(parent:Canvas)}      
	 {Canvas tk(crea text X Y-5 o(text:"") tag:q(self.textTag self.tag))}
	 {Canvas setScrollRegion}
	 {self.tag tkBind(event:'<1>' action:Popup)}
      end
      meth popupMenu() raise uiNodeparentPopupMenue end end
      meth getCoords($) @coords end
      meth getColor($) @color end
      meth remove
	 {self.tag tk(delete)}
      end
      meth updateText(TextList)
	 X#Y=@coords
      in
	 if @text\=TextList then
	    text<-TextList
	    {self.textTag tk(delete)}
	    {self.canvas tk(crea text X Y-5 o(text:"") tag:self.textTag)}
	    {List.forAllInd TextList proc{$ Ind M}
					if Ind>0 then
					   {self.canvas
					    tk(crea text X Y + (Ind - 1)  *
					       15 o(text:{Convert M})
					       tag:q(self.textTag self.tag))}
					end
				     end}
	 end
      end
   end

   class GLink
      prop
	 locking % only for YellowPopup
      feat
	 slots
	 nofslots
	 coords
	 canvas
	 tag
	 Msgs
      attr
	 YellowPopupTag

      meth init(id:Id
		fromcoords:FXFY fromnodesize:FW
		tocoords:TXTY tonodesize:TW
		nofslots:NofSlots parent:Canvas)
	 FX#FY=FXFY
	 TX#TY=TXTY
      in
	 self.slots={NewArray 1 NofSlots slot(centercoords:_)}
	 self.nofslots=NofSlots
	 self.Msgs={NewDictionary}
	 self.coords=(FX#FY)#(TX#TY)
	 self.canvas=Canvas
	 self.tag={New Tk.canvasTag tkInit(parent:Canvas)}
	 YellowPopupTag<-nil
	 {self FillInSlotsArray(FW TW)}
	 {self draw(black)}
      end
      
      meth remove
	 % Remove any messages
	 for I in {Dictionary.items self.Msgs} do
	    msg(tag:Tag...)=I
	 in
	    {Tag tk(delete)}
	 end
	 % Remove line
	 {self.tag tk(delete)}
      end

      meth update(NewState)
	 state(messages:NewMsgArray flushing:Flushing ...)=NewState
	 % Find all messages in MsgArray
	 NewMsgDict={NewDictionary}
	 NofSlots=self.nofslots
      in
	 % Remove any yellow popup
	 {self RemoveYellowPopup}

         % If flushing, turn red
	 if Flushing then {self draw(red)} end
	 
	 % Extract all messages from MsgArray
	 {For 1 NofSlots 1
	  proc{$ I}
	     Cur=NewMsgArray.I
	  in
	     case Cur of nil then skip else
		Id = Cur.id
	     in
		NewMsgDict.Id:=Cur#I
	     end
	  end}

	 % Update all old messages
	 % Remove those found in NewMsgDict from there to find the
	 % new ones later.
	 {ForAll {Dictionary.entries self.Msgs}
	  proc{$ Id#M}
	     NMS={Dictionary.condGet NewMsgDict Id remove}
	     msg(obj:Obj tag:Tag ...)=M
	  in
	     case NMS of remove then
		{Tag tk(delete)}
		{Dictionary.remove self.Msgs Id}
	     [] _/*Obj*/#NewPos then
		{self moveMsg(self.Msgs.Id.pos NewPos Tag)}
		self.Msgs.Id:=msg(obj:Obj pos:NewPos tag:Tag)
		{Dictionary.remove NewMsgDict Id}
	     end
	  end}

	 % Insert new messages
	 {ForAll {Dictionary.entries NewMsgDict} 
	  proc{$ Id#(Obj#Pos)}
	     Tag
	  in
	     {self drawMsg(Obj Id Pos {Obj getMessageColor($)}
			   {Obj getMessageShape($)} Tag)}
	     self.Msgs.Id:=msg(obj:Obj pos:Pos tag:Tag)
	  end}
      end

      meth browseMsg(Id)
	 {Browser.browse {self.Msgs.Id.obj toString($)}}
      end
      
      meth drawMsg(Obj Id Pos Col Rep ?Tag)
	 CX#CY=self.slots.Pos.centercoords
	 Rec 
      in
	 Tag={New Tk.canvasTag tkInit(parent:self.canvas)}
	 {Tag tkBind(event:'<Enter>' action:self#ShowYellowPopup(Obj Tag))}
	 {Tag tkBind(event:'<Leave>' action:self#RemoveYellowPopup)}
	 {Tag tkBind(event:'<1>' action:self#browseMsg(Id))}
	 Rec = case Rep of circle then
		  tk(crea oval
		     CX-MsgRadius CY-MsgRadius
		     CX+MsgRadius CY+MsgRadius
		     width:1 fill:Col tags:Tag)
	       elseof square then 
		  tk(crea rect
		     CX-MsgRadius CY-MsgRadius
		     CX+MsgRadius CY+MsgRadius
		     width:1 fill:Col tags:Tag)
		  
	       elseof triangle then
		  Base =  (4 * MsgRadius) div 3
		  Height = (4 * MsgRadius) div 3
	       in
		  tk(crea polygon
		     CX-Base CY+Height
		     CX+Base CY+Height
		     CX           CY- Height
		     width:1 fill:Col tags:Tag outline:black)
	       elseof hexagon then
		  Height = MsgRadius
		  Width  = MsgRadius
		  MidWith = (4 * MsgRadius) div 3
	       in
		  tk(crea polygon
		     CX- Width    CY+Height
		     CX+ Width    CY+ Height 
		     CX+ MidWith  CY
		     CX+ Width    CY-Height
		     CX- Width    CY-Height
		     CX- MidWith  CY
		     width:1 fill:Col tags:Tag outline:black)
	       end
	 {self.canvas Rec}
      end
	 
      meth moveMsg(OldPos NewPos Tag)
	 NX#NY=self.slots.NewPos.centercoords
	 OX#OY=self.slots.OldPos.centercoords
      in
%	 {System.show o(OX#OY '=>' NX#NY '==' 
	 {self.canvas tk(move Tag NX-OX NY-OY)}
      end

      meth FillInSlotsArray(FW TW)
	 (FX#FY)#(TX#TY)=self.coords % int coords from#to
	 % Float versions
	 FX1={IntToFloat FX}
	 FX2={IntToFloat TX}
	 FY1={IntToFloat FY}
	 FY2={IntToFloat TY}
	 % Points offset to edge of node
	 OFX OFY OTX OTY
	 % Distance between every slot
	 DX DY
	 NofSlots=self.nofslots
	 FNofSlots={IntToFloat self.nofslots}
	 HalfFW={IntToFloat FW}/2.0
	 HalfTW={IntToFloat TW}/2.0
      in
	 % Using y=kx+m unless k=infinity
	 if FX-TX==0 then
	    OFX=FX1 OTX=FX2
	    if FY2>FY1 then
	       OFY=FY1+HalfFW
	       OTY=FY2-HalfTW
	    else
	       OFY=FY1-HalfFW
	       OTY=FY2+HalfTW
	    end	       
	    DX=0.0 DY=(OTY-OFY) / FNofSlots
	 else K in
	    K = (FY2-FY1)/(FX2-FX1)
	    if {Abs K}<1.0 then % Align to vertical line
	       if FX2>FX1 then % the right one at F, left at T
		  OFX=FX1+HalfFW
		  OFY=FY1+HalfFW*K
		  OTX=FX2-HalfFW
		  OTY=FY2-HalfFW*K
	       else
		  OFX=FX1-HalfFW
		  OFY=FY1-HalfFW*K
		  OTX=FX2+HalfFW
		  OTY=FY2+HalfFW*K
	       end
	    else % Align to horisontal line
	       if FY2>FY1 then % upper one at F, lower at T
		  OFX=FX1+HalfFW/K  
		  OFY=FY1+HalfFW
		  OTX=FX2-HalfFW/K
		  OTY=FY2-HalfFW
	       else
		  OFX=FX1-HalfFW/K
		  OFY=FY1-HalfFW
		  OTX=FX2+HalfFW/K
		  OTY=FY2+HalfFW
	       end
	    end
	    DX = (OTX-OFX) / FNofSlots
	    DY = K*DX
	 end

	 for I in 1..NofSlots do
	    CX CY
	    self.slots.I:=slot(centercoords:CX#CY)
	    IF={IntToFloat I}
	 in
	    CX={FloatToInt (OFX+DX*IF-DX/2.0)}
	    CY={FloatToInt (OFY+DY*IF-DY/2.0)}
	 end
      end

      meth draw(Color)
         % Draw 3 lines with arrows to make up 1 line with 3 arrows
	 (FX#FY)#(TX#TY)=self.coords
	 DX=((TX-FX) div 3)
	 DY=((TY-FY) div 3)
      in
	 for M in 1..3 do
	    {self.canvas tk(crea line
			    FX FY (FX+DX*M) (FY+DY*M)
			    arrow:last
			    fill:Color
			    tags:self.tag)}
	 end
	 {self.canvas tk(lower self.tag)}
      end

      meth ShowYellowPopup(Msg MsgTag) Ret in
	 lock
	    {self RemoveYellowPopup}
	    YellowPopupTag<-{New Tk.canvasTag tkInit(parent:self.canvas)}
	    Ret = {self.canvas tkReturnListInt(bbox MsgTag $)}
	    case Ret of X1|Y1|_ then
	       TextTag={New Tk.canvasTag tkInit(parent:self.canvas)}
	    in
	       {self.canvas tk(crea text X1+TextOffset Y1-TextOffset
			       o(text:{Msg toShortString($)}
				 tags:q(@YellowPopupTag TextTag)))}
	       local 
		  [X0 Y0 X1 Y1]={self.canvas
				 tkReturnListInt(bbox @YellowPopupTag $)}
	       in
		  {self.canvas tk(crea rectangle
				  X0-4 Y0 X1+4 Y1
				  fill:yellow tags:@YellowPopupTag)}
		  {self.canvas tk('raise' TextTag)}
	       end
	    end
	 end
      end

      meth RemoveYellowPopup
	 lock
	    if @YellowPopupTag\=nil then
	       {@YellowPopupTag tk(delete)}
	       YellowPopupTag<-nil
	    end
	 end
      end
   end
end
