functor
export
   NodeLinkGraphics
import
   Utils(min:Min getDistance:GetDistance) at '../Utils.ozf'
   Graphics(nodeLinkFrame:NodeLinkFrame
	    gNode:GNode gLink:GLink)
define
   % Settings - move out of here
   NodeWidth=80
   LinkOffset=5
   % Limit implied by implementation of CalcColor and CalcCoords
   MaxNodes=16
   
   class NodeLinkGraphics
      feat
	 canvas
	 Nodes
	 Links
	 Size
      attr
	 nodeindex
	
      meth init(TopLevel width:W<=500 height:H<=500 ?Frame)
	 Frame={New NodeLinkFrame tkInit(parent:TopLevel
					 width:W height:H)}
	 self.canvas=Frame.canvas
	 self.Nodes={NewDictionary}
	 self.Links={NewDictionary}
         % Set the radius to be half of 80 percent of the least of W and H
	 self.Size=r(width:W height:H radius:({Min W H} * 80 div 200))
	 nodeindex<-1
      end

      meth step(_/*Time*/ LinkState)
	 {ForAll LinkState
	  proc{$ LS}
	     state(id:Id ...)=LS
	  in
	     {self.Links.Id update(LS)}
	  end}
      end

      meth createNode(NodeId GraphSpec)
	 I
      in
	 if @nodeindex>MaxNodes then
	    raise too_many_nodes(max:MaxNodes) end
	 else N in
	    I=nodeindex<-N
	    N=I+1
	 end
	 self.Nodes.NodeId:={New GNode init(id:NodeId
					    coords:{CalcCoords GraphSpec
						    self.Size I}
					    color:{CalcColor GraphSpec I}
					    parent:self.canvas
					    width:NodeWidth
					    popup:{GetPopup GraphSpec})}
      end

      meth removeNode(NodeId)
	 Node=self.Nodes.NodeId
      in
	 {Node remove}
	 {Dictionary.remove self.Nodes NodeId}
      end
      
      meth createLink(LinkId FromNodeId ToNodeId NofSlots)
	 FX#FY={self.Nodes.FromNodeId getCoords($)}
	 TX#TY={self.Nodes.ToNodeId getCoords($)}
	 % Adjusted coordinates, links in oposite direciton drawn
	 % apart.
	 AFX AFY ATX ATY
	 Dir
	 % Sizes of the nodes to be used to find the border
	 FW=self.Nodes.FromNodeId.width
	 TW=self.Nodes.ToNodeId.width
      in
	 if TX>FX then Dir=1
	 elseif TX<FX then Dir=~1
	 elseif TY>FY then Dir=1
	 else Dir=~1 end
	 if {Abs TY-FY} > {Abs TX-FX} then
	    AFX#AFY=FX+LinkOffset*Dir#FY
	    ATX#ATY=TX+LinkOffset*Dir#TY
	 else
	    AFX#AFY=FX#FY+LinkOffset*Dir
	    ATX#ATY=TX#TY+LinkOffset*Dir
	 end
	 self.Links.LinkId:={New GLink init(id:LinkId
					    fromcoords:AFX#AFY
					    fromnodesize:FW
					    tocoords:ATX#ATY
					    tonodesize:TW
					    nofslots:NofSlots
					    parent:self.canvas)}
      end

      meth removeLink(L)
	 Link=self.Links.L
      in
	 {Link remove}
	 {Dictionary.remove self.Links L}
      end

      meth calcNofSlots(FromNodeId ToNodeId ?N)
	 N={CalcNofSlots self.Nodes.FromNodeId self.Nodes.ToNodeId}
      end

      meth getColorOfNode(NodeId $)
	 {self.Nodes.NodeId getColor($)}
      end

      meth updateNodeText(NodeId TextList)
	 {self.Nodes.NodeId updateText(TextList)}
      end
   end

   fun{CalcNofSlots FromNode ToNode}
      FX#FY={FromNode getCoords($)}
      TX#TY={ToNode getCoords($)}
   in
      ({GetDistance FX#FY TX#TY} div 20)
   end

   fun{CalcCoords GraphSpec Size I}
      Coords={CondSelect GraphSpec coords auto}
   in
      if Coords \= auto then Coords else
	 CoordVals = r(1.0 1.0/2.0
		       1.0/4.0 3.0/4.0
		       1.0/8.0 3.0/8.0 5.0/8.0 7.0/8.0
		       1.0/16.0 3.0/16.0 5.0/16.0 7.0/16.0 9.0/16.0 11.0/16.0
		       13.0/16.0 15.0/16.0)
	 r(width:W height:H radius:Radius)=Size
	 Rad=((6.28*CoordVals.I) - 3.14/2.0)
	 FRadius={IntToFloat Radius}
	 X#Y={FloatToInt {Cos Rad}*FRadius}#{FloatToInt {Sin Rad}*FRadius}
      in
	 (X+(W div 2))#(Y+(H div 2))
      end
   end
   
   fun{CalcColor GraphSpec I}
      Color={CondSelect GraphSpec color auto}
   in
      if Color \= auto then Color else
	 Colors = r(green red blue darkgreen
		    gray lightblue darkred seashell
		    pink ghostwhite cornsilk aquamarine
		    steelblue tan salmon ivory)
      in
	 Colors.I
      end
   end

   fun{GetPopup GraphSpec}
      {CondSelect GraphSpec popup proc{$} skip end}
   end
end
